/*
 * gml_Types.h --
 *
 *    Type definitions used in the gml.
 */
/*
 *  Copyright (c) 1995-2002 CLIPS-IMAG
 *
 *  See the file "gml_LicenseTerms.txt" for information on usage and redistribution
 *  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 *  Created on July, 1995 (FB).
 */

#ifndef __GML_TYPES__
#define __GML_TYPES__

#include <sys/types.h>
#include <stdio.h>

typedef unsigned char        UInt8;             /**< 1 byte integer */
typedef unsigned short       UInt16;            /**< 2 bytes integer */
typedef unsigned long        UInt32;            /**< 4 bytes integer */

typedef signed char          SInt8;             /**< 1 byte signed integer */
typedef signed short         SInt16;            /**< 2 bytes signed integer */
typedef signed long          SInt32;            /**< 4 bytes signed integer */

typedef float                Float32;           /**< 32-bit floating point */
typedef double               Float64;           /**< 64-bit floating point */

typedef size_t               gml_TBlockSize;    /**< size of a block of memory */

typedef UInt8                gml_TByte;

typedef void*                gml_TPointer;      /**< type of polymorphic pointers */

/** compiler-independent boolean type */
typedef enum {
  gml_cFalse = (0 == 1),
  gml_cTrue  = (1 == 1)
} gml_TBoolean;

/* gmlOffset --
 *
 *  Computed the number of bytes from to beginning of a struct to a field.
 *  Copied from Tk_Offset.
 */
#define gmlOffset(type, field) ((int) ((char *) &((type *) 0)->field))

#ifndef NULL
#define NULL 0
#endif

#ifdef _WIN32
  #define LITTLE_ENDIAN 1234
  #define BIG_ENDIAN    4321

  #define BYTE_ORDER    LITTLE_ENDIAN
#endif


#endif
