// gmlTcl_Object.h --
//
//    Declares the gmlTcl_TObject class. An object of this class represents a
//    Tcl-level gmlObject object.
//
//  Copyright (c) 2007 LIG/IIHM
//
//  See the file "gml_LicenseTerms.txt" for information on usage and redistribution
//  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
//
//  Created on June 22, 2007 (FB).

#ifndef __GMLTCL_OBJECT__
#define __GMLTCL_OBJECT__

extern "C" {
  #include "tcl.h"
}

#include "gmlTcl_Entity.h"


class gmlTcl_TClass;

class gmlTcl_TObject : public gmlTcl_TEntity
{
  public:

    // Public object methods

    int                     Init               (Tcl_Interp*         interp,
                                                gmlTcl_TClass*      theClass,
                                                int                 objc,
                                                Tcl_Obj*            objv[]);
    
    void                    Dispose            ();

    int                     CommandHandler     (Tcl_Interp*         interp,
                                                int                 objc,
                                                Tcl_Obj*            objv[]);

    int                     MethodDispatchCmd  (Tcl_Interp*         interp,
                                                Tcl_Obj*            objName,
                                                int                 objc,
                                                Tcl_Obj*            objv[]);


    // Accessors, Modifiers

    gmlTcl_TClass*          Class              () { return fClass;      }


  protected:

    // Object attributes

    gmlTcl_TClass*          fClass;           // the class of this object
    int                     fRegistered;      // true if this object has been registered to its class
    int                     fConstructed;     // true if the desctructor must be called on dispose
};


#endif
